Index: main/plugin-core/sitemap.xmap
===================================================================
--- main/plugin-core/sitemap.xmap	(revision 31811)
+++ main/plugin-core/sitemap.xmap	(working copy)
@@ -66,11 +66,11 @@
 		<map:actions>
             <map:action name="set-header" src="org.apache.cocoon.acting.HttpHeaderAction" logger="org.ametys.runtime.plugins.core.administrator.sitemap.action.httpHeader"/>
 
+            <map:action name="administrator-logs-level" src="org.ametys.runtime.plugins.core.administrator.logs.GetLogsLevel" logger="org.ametys.runtime.plugins.core.administrator.sitemap.generator.logs" label="content"/>	            
+
             <map:action name="administrator-is-system-user" src="org.ametys.runtime.plugins.core.right.actions.IsAdminAction" logger="org.ametys.runtime.plugins.core.administrator.sitemap.action.isAdmin"/>
 			<map:action name="administrator-password-set" src="org.ametys.runtime.plugins.core.administrator.password.SetPasswordAction" logger="org.ametys.runtime.plugins.core.administrator.sitemap.action.setPassword"/>
             <map:action name="administrator-jvmstatus-gc" src="org.ametys.runtime.plugins.core.administrator.jvmstatus.GCAction" logger="org.ametys.runtime.plugins.core.administrator.sitemap.action.garbageCollect"/>
-            <map:action name="administrator-logs-delete" src="org.ametys.runtime.plugins.core.administrator.logs.LogsDeleteAction" logger="org.ametys.runtime.plugins.core.administrator.sitemap.action.logDelete"/>
-            <map:action name="administrator-change-levels" src="org.ametys.runtime.plugins.core.administrator.logs.ChangeLogLevelAction" logger="org.ametys.runtime.plugins.core.administrator.logs.ChangeLogLevelAction"/>
             <map:action name="administrator-system-update" src="org.ametys.runtime.plugins.core.administrator.system.UpdateSystemAction" logger="org.ametys.runtime.plugins.core.administrator.sitemap.action.updateSystem"/>
             <map:action name="administrator-config-save" src="org.ametys.runtime.plugins.core.administrator.configuration.SaveConfigAction" logger="org.ametys.runtime.plugins.core.administrator.sitemap.action.saveConfig"/>
             <map:action name="administrator-config-test" src="org.ametys.runtime.config.ParameterCheckerAction" logger="org.ametys.runtime.plugins.core.administrator.sitemap.action.dispatchRequest"/>
@@ -313,26 +313,8 @@
                 <map:read type="administrator-jvmstatus-monitoring-export" src="{1}"/>
             </map:match>
             
-            
-            <!-- +
-                 | Logs 
-                 + -->
-            <map:match pattern="administrator/logs/view.html">
-                <map:generate type="administrator-logs" label="content"/>
-                <map:transform type="xslt" src="pages/administrator/logs/view.xsl">
-                    <map:parameter name="contextPath" value="{request:contextPath}"/>
-                    <map:parameter name="pluginName" value="{request-attr:pluginName}"/>
-                    <map:parameter name="workspaceName" value="{request-attr:workspaceName}"/>
-                    <map:parameter name="workspaceURI" value="{request-attr:workspaceURI}"/>
-                </map:transform>
-                <map:transform type="i18n">
-                    <map:parameter name="locale" value="{locale:locale}"/>
-                    <map:parameter name="plugin" value="{request-attr:pluginName}"/>
-                </map:transform>
-                <map:serialize type="xml"/>
-            </map:match>
-        
 		</map:pipeline>
+		
 		<map:pipeline type="noncaching">
             <map:match pattern="administrator/logs/view/*.log">
                 <map:act type="set-header"> 
@@ -349,38 +331,25 @@
                 <map:serialize type="zip"/>
             </map:match>
 		</map:pipeline>
+		
 		<map:pipeline>
-            <map:match pattern="administrator/logs/delete">
-                <map:act type="administrator-logs-delete">
-                    <map:generate type="action-result">
-                        <map:parameter name="failure" value="{failure}"/>
-                    </map:generate>
-                    <map:serialize type="xml"/>
-                </map:act>
-            </map:match>
-
-            <map:match pattern="administrator/logs/purge">
-                <map:act type="administrator-logs-delete">
-                    <map:parameter name="purge" value="true"/>
-                
-                    <map:generate type="action-result">
-                        <map:parameter name="done" value="{done}"/>
-                    </map:generate>
-                    <map:serialize type="xml"/>
-                </map:act>
+		
+		    <!-- +
+                 | Logs 
+                 + -->
+            <map:match pattern="administrator/logs">
+                <map:generate type="administrator-logs"/>
+                <map:serialize type="xml"/>
             </map:match>
             
-            <map:match pattern="administrator/logs/change-levels">
-                <map:act type="administrator-change-levels">
-                    <map:generate type="action-result">
-                        <map:parameter name="error" value="{error}"/>
-                    </map:generate>
-                    <map:serialize type="xml"/>
+            <map:match pattern="administrator/logs-level">
+                <map:act type="administrator-logs-level">
+                    <map:read type="json"/>
                 </map:act>
             </map:match>
-            
+
             <!-- +
-                 | Plugins and workspaces managment tool
+                 | Plugins and workspaces management tool
                  + -->
             <map:match pattern="administrator/plugins/list.xml">
                 <map:generate type="administrator-plugins-list"/>
Index: main/plugin-core/src/org/ametys/runtime/plugins/core/administrator/logs/GetLogsLevel.java
===================================================================
--- main/plugin-core/src/org/ametys/runtime/plugins/core/administrator/logs/GetLogsLevel.java	(revision 0)
+++ main/plugin-core/src/org/ametys/runtime/plugins/core/administrator/logs/GetLogsLevel.java	(revision 0)
@@ -0,0 +1,176 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.runtime.plugins.core.administrator.logs;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Enumeration;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+
+import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.cocoon.acting.ServiceableAction;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.environment.Redirector;
+import org.apache.cocoon.environment.Request;
+import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.lang3.StringUtils;
+import org.apache.log4j.Level;
+import org.apache.log4j.LogManager;
+import org.apache.log4j.Logger;
+import org.apache.log4j.spi.LoggerRepository;
+
+import org.ametys.runtime.cocoon.JSonReader;
+
+/**
+ * Get the log levels' 
+ */
+@SuppressWarnings("unchecked")
+public class GetLogsLevel extends ServiceableAction
+{
+    public Map act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
+    {
+        Request request = ObjectModelHelper.getRequest(objectModel);
+        Map<String, Object> result = new HashMap<> ();
+        
+        try
+        {
+            LoggerRepository loggerRepository = LogManager.getLoggerRepository();
+            List<Logger> loggers = new ArrayList<Logger>();
+            Enumeration<org.apache.log4j.Logger> enumLogger = loggerRepository.getCurrentLoggers();
+            
+            while (enumLogger.hasMoreElements())
+            {
+                loggers.add(enumLogger.nextElement());
+            }
+            
+            loggers.add(loggerRepository.getRootLogger());
+            
+            Collections.sort(loggers, new LoggerComparator());
+            
+            Map<String, Object> logCategories = new HashMap<>();
+            Set<Map<String, String>> categoryLevels = new HashSet<Map<String, String>> ();
+            
+            for (Logger logger : loggers)
+            {
+                Level level = logger.getLevel();
+
+                String category = logger.getName();
+                if (category.equals("root"))
+                {
+                    logCategories.put("children", new ArrayList<> ());
+                    logCategories.put("name", "root");
+                    logCategories.put("fullname", "root");
+                    logCategories.put("level", level.toString());
+                }
+                else
+                {
+                    Map<String, String> categoryLevel = new HashMap<>();
+                    categoryLevel.put("category", category);
+                    categoryLevel.put("level", level == null ? "inherit" : level.toString());
+                    categoryLevels.add(categoryLevel);
+                }
+            }
+
+            String fullName = null;
+            for (Map<String, String> categoryLevel : categoryLevels)
+            {
+                fullName = categoryLevel.get("category");
+                createCategory((List<Map<String, Object>>) logCategories.get("children"), fullName, categoryLevel.get("level"), fullName);
+            }
+            
+            result.put("children", logCategories);
+        }
+        catch (Exception e) 
+        {
+             // nothing to do
+            getLogger().warn("Unable to access internal logger properties", e);
+        }
+        
+        request.setAttribute(JSonReader.OBJECT_TO_READ, result);
+        return EMPTY_MAP;
+    }
+    
+    /**
+     * Creates a log category 
+     * @param children the list of categories already created
+     * @param categoryName the name of the category to create
+     * @param level the level of the category to create
+     * @param fullName the full name of the category
+     */
+    public void createCategory(List<Map<String, Object>> children, String categoryName, String level, String fullName)
+    {
+        int i = categoryName.indexOf(".");
+        if (i != -1)
+        {
+            // Creates intermediary tree nodes
+            String parentCategoryName = categoryName.substring(0, i);
+            String childCategoryName = categoryName.substring(i + 1);
+            
+            Map<String, Object> parentCategoryNode = _getNode(children, parentCategoryName);
+            
+            if (parentCategoryNode == null)
+            {
+                // We did not find any existing node, let's create it
+                parentCategoryNode = new HashMap<> ();
+                parentCategoryNode.put("children", new ArrayList<> ());
+                parentCategoryNode.put("level", "inherit");
+                parentCategoryNode.put("name", parentCategoryName);
+                parentCategoryNode.put("fullname", fullName.substring(0, fullName.indexOf(parentCategoryName)) + parentCategoryName);
+                
+                children.add(parentCategoryNode);
+            }
+            
+            createCategory((List<Map<String, Object>>) parentCategoryNode.get("children"), childCategoryName, level, fullName);
+        }
+        else
+        {
+            Map<String, Object> categoryNode = _getNode(children, categoryName);
+            if (categoryNode == null)
+            {
+                // Creates tree leaves
+                categoryNode = new HashMap<> ();
+                
+                categoryNode.put("children", new ArrayList<> ());
+                categoryNode.put("level", level);
+                categoryNode.put("name", categoryName);
+                categoryNode.put("fullname", fullName);
+    
+                children.add(categoryNode);
+            }
+            else
+            {
+                // The intermediary node was already created, let's update it
+                categoryNode.put("level", level);
+            }
+        }
+    }
+    
+    private Map<String, Object> _getNode(List<Map<String, Object>> children, String categoryName)
+    {
+        for (Map<String, Object> child : children)
+        {
+            if (StringUtils.equals((String) child.get("name"), categoryName))
+            {
+                return child;
+            }
+        }
+        return null;
+    }
+}
Index: main/plugin-core/src/org/ametys/runtime/plugins/core/administrator/logs/LoggerComparator.java
===================================================================
--- main/plugin-core/src/org/ametys/runtime/plugins/core/administrator/logs/LoggerComparator.java	(revision 0)
+++ main/plugin-core/src/org/ametys/runtime/plugins/core/administrator/logs/LoggerComparator.java	(revision 0)
@@ -0,0 +1,61 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.runtime.plugins.core.administrator.logs;
+
+import java.util.Comparator;
+
+import org.apache.log4j.Logger;
+
+/**
+ * Comparator to compare two loggers by their name 
+ */
+public class LoggerComparator implements Comparator<Logger>
+{
+    public int compare(Logger o1, Logger o2)
+    {
+        String[] o1NameParts = o1.getName().split("\\.");
+        String[] o2NameParts = o2.getName().split("\\.");
+        int i = 0;
+        
+        for (; i < o1NameParts.length && i < o2NameParts.length; i++)
+        {
+            int compare = o1NameParts[i].compareTo(o2NameParts[i]);
+            
+            if (compare != 0)
+            {
+                return compare;
+            }
+            
+            // Same category, continue
+        }
+        
+        if (i == o1NameParts.length)
+        {
+            if (i != o2NameParts.length)
+            {
+                // o2 has a longer category
+                return 1;
+            }
+        }
+        else
+        {
+            // o1 has a longer category
+            return -1;
+        }
+        
+        return o1.getName().compareTo(o2.getName());
+    }
+}
Index: main/plugin-core/src/org/ametys/runtime/plugins/core/administrator/logs/LogsClientSideElement.java
===================================================================
--- main/plugin-core/src/org/ametys/runtime/plugins/core/administrator/logs/LogsClientSideElement.java	(revision 0)
+++ main/plugin-core/src/org/ametys/runtime/plugins/core/administrator/logs/LogsClientSideElement.java	(revision 0)
@@ -0,0 +1,275 @@
+package org.ametys.runtime.plugins.core.administrator.logs;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Calendar;
+import java.util.Date;
+import java.util.Enumeration;
+import java.util.GregorianCalendar;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.ProcessingException;
+import org.apache.excalibur.source.ModifiableSource;
+import org.apache.excalibur.source.ModifiableTraversableSource;
+import org.apache.excalibur.source.SourceException;
+import org.apache.excalibur.source.SourceResolver;
+import org.apache.excalibur.source.TraversableSource;
+import org.apache.log4j.Level;
+import org.apache.log4j.LogManager;
+import org.apache.log4j.Logger;
+import org.apache.log4j.spi.LoggerRepository;
+
+import org.ametys.runtime.ui.Callable;
+import org.ametys.runtime.ui.StaticClientSideElement;
+
+/**
+ * Client side element for log actions
+ */
+public class LogsClientSideElement extends StaticClientSideElement
+{
+    /** The path to the application's logs folder */
+    private static final String __LOGS_BASE = "context://WEB-INF/logs/";
+    
+    /** The Excalibur source resolver */
+    private SourceResolver _sourceResolver;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        super.service(serviceManager);
+        _sourceResolver = (SourceResolver) serviceManager.lookup(SourceResolver.ROLE);
+    }
+    
+    /**
+     * Delete the logs at the specified locations
+     * @param files list of file ids mapped with their relative location from the logs folder
+     * @return a map
+     * @throws IOException 
+     * @throws ProcessingException 
+     */
+    @Callable
+    public Map<String, Object> deleteLogs(List<String> files) throws ProcessingException, IOException
+    {
+        Map<String, Object> result = new HashMap<>();
+        List<String> failures = new ArrayList<> ();
+        List<String> successes = new ArrayList<> ();
+        
+        if (getLogger().isInfoEnabled())
+        {
+            getLogger().info("Administrator starts a deletion of " + files.size() + " logged file");
+        }
+        
+        // Delete the selected files one by one
+        for (String location : files)
+        {
+            if (_deleteFile(location))
+            {
+                successes.add(location);
+            }
+            else
+            {
+                failures.add(location);
+            }
+        }
+        
+        if (getLogger().isInfoEnabled())
+        {
+            getLogger().info("Process terminated with following results : failure '" + failures.toString() + " successes '" + successes.toString());
+        }
+        
+        result.put("failures", failures);
+        result.put("successes", successes);
+        return result;
+    }
+    
+    /**
+     * Delete the log entries that are at least 12 days old
+     * @return a map
+     * @throws ProcessingException if an exception occurs while processing the deletion
+     */
+    @Callable
+    public Map<String, Object> purgeLogs() throws ProcessingException
+    {
+        Map<String, Object> result = new HashMap<> ();
+        
+        Calendar purgeCalendar = new GregorianCalendar();
+        purgeCalendar.add(Calendar.DAY_OF_MONTH, -12);
+        Date purgeDate = new Date(purgeCalendar.getTimeInMillis());
+
+        if (getLogger().isDebugEnabled())
+        {
+            getLogger().debug("Starting purge...");
+            getLogger().debug("Purge date is " + purgeDate);
+        }
+
+        List<String> filesList = new ArrayList<String>();
+        TraversableSource logsSources = null;
+        try
+        {
+            logsSources = (TraversableSource) _sourceResolver.resolveURI(__LOGS_BASE);
+            for (Object log : logsSources.getChildren())
+            {
+                ModifiableTraversableSource logSource = (ModifiableTraversableSource) log;
+                if (!logSource.isCollection() && logSource.getURI().endsWith(".log") && new Date(logSource.getLastModified()).before(purgeDate))
+                {
+                    String location = logSource.getURI();
+                    String name = location.substring(location.lastIndexOf('/') + 1);
+                    filesList.add(name);
+                    if (getLogger().isDebugEnabled())
+                    {
+                        getLogger().debug("Adding file to purge : " + name);
+                    }
+                }
+            }
+            
+            result.put("filesToPurge", filesList);
+            return result;
+        }
+        catch (SourceException e)
+        {
+            String message = "The purge of old log files failed";
+            getLogger().error(message, e);
+            throw new ProcessingException(message, e);
+        }
+        catch (IOException e)
+        {
+            String message = "The log directory was not found";
+            getLogger().error(message, e);
+            throw new ProcessingException(message, e);
+        }
+        finally
+        {
+            if (logsSources != null)
+            {
+                _sourceResolver.release(logsSources);
+            }
+        }  
+    }
+    
+    private boolean _deleteFile(String fileLocation) throws IOException, ProcessingException
+    {
+        if (fileLocation.indexOf("/") != -1 || fileLocation.indexOf('\\') != -1)
+        {
+            String message = "The LogsDeleteAction has been call with the forbiden parameter '" + fileLocation + "'";
+            getLogger().error(message);
+            throw new ProcessingException(message);
+        }
+        
+        ModifiableSource logsource = null;
+        try
+        {
+            if (fileLocation.endsWith(".log"))
+            {
+                logsource = (ModifiableSource) _sourceResolver.resolveURI(__LOGS_BASE + fileLocation);
+                if (getLogger().isInfoEnabled())
+                {
+                    getLogger().info("Removing log file " + logsource.getURI());
+                }
+                logsource.delete();
+                return true;
+            }
+            else if (getLogger().isWarnEnabled())
+            {
+                getLogger().warn("Ignoring this file during deletion '" + "' because it does not ends with .log");
+            }
+            return false;
+        }
+        catch (SourceException e)
+        {
+            getLogger().error("The administrator tried unsuccessfully to remove the following log file '" + (logsource != null ? logsource.getURI() : fileLocation) + "'.", e);
+            return false;
+        }
+        finally
+        {
+            if (logsource != null)
+            {
+                _sourceResolver.release(logsource);
+            }
+        }
+    }
+    
+    /**
+     * Change the log level of the selected category to the selected level
+     * @param level the selected level
+     * @param category the selected category
+     * @return a map
+     */
+    @Callable
+    public Map<String, Object> changeLogLevel(String level, String category)
+    {
+        Map<String, Object> result = new HashMap<>();
+        
+        if (getLogger().isInfoEnabled())
+        {
+            getLogger().info("Administrator change log level");
+        }
+
+        LoggerRepository loggerRepository = LogManager.getLoggerRepository();
+        
+        if (getLogger().isInfoEnabled())
+        {
+            getLogger().info("Log level changing category '" + category + "' " + level);
+        }
+
+        try
+        {
+            _changeLogLevel(loggerRepository, category, level);
+        }
+        catch (Throwable t)
+        {
+            String errorMessage = "Cannot change log level correctly : changing category '" + category + "'";
+            getLogger().error(errorMessage, t);
+            result.put("error", "error");
+            return result;
+        }
+        
+        return result;
+    }
+    
+    private void _changeLogLevel(LoggerRepository loggerRepository, String category, String mode)
+    {
+        boolean inherited = "INHERIT".equals(mode) || "INHERITFORCED".equals(mode);
+        boolean force = "FORCE".equals(mode) || "INHERITFORCED".equals(mode);
+
+        Logger logger;
+        boolean isRoot = false;
+        
+        if ("root".equals(category))
+        {
+            isRoot = true;
+            logger = loggerRepository.getRootLogger();
+        }
+        else
+        {
+            logger = loggerRepository.getLogger(category);
+        }
+    
+        if (inherited && !isRoot)
+        {
+            logger.setLevel(null);
+        }
+        
+        if (force)
+        {
+            Enumeration<Logger> e = loggerRepository.getCurrentLoggers();
+            while (e.hasMoreElements())
+            {
+                Logger l = e.nextElement();
+                if (l.getParent() == logger)
+                {
+                    _changeLogLevel(loggerRepository, l.getName(), "INHERITFORCED");
+                }
+            }
+        }
+
+        if (!inherited && !force)
+        {
+            Level level = Level.toLevel(mode);
+            logger.setLevel(level);
+        }
+    }
+}
